#include <MyMenu.h>
#include <encoder.h>

// Шаблон приложения с одноуровненвым меню. Меню будет управляться экодером. 
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <MyMenu.h>

#define NUM_ITEMS 11 //total number of items in menu include submenu-headers
#define NUM_ROWS 2 //total number of rows in your lcd, must be greater than or equal to 2

 MItm  items[NUM_ITEMS] = {
  MItm("HI i'm main menu",0,0), //main header, always 0,0
  MItm("first",1), //second parameter is submenu-index, which will be opened by this item
  MItm("Second item",2),
  MItm("FIRST SUBMENU",1,0), //sub-menu header (two input parameters), 1 is submenu index, any unique integer for submenus, 0 is previous-menu index for right hierarchy
  MItm("Submenu item one",3),
  MItm("Sub item two",4),
  MItm("BACK",0), //optional BACK item
  MItm("SECOND SUBMENU",2,0),
  MItm("Submenu item one",5),
  MItm("Sub item two",6),
  MItm("BACK",0) 
};

String cursor = "-"; // the menu cursor, by default is ">"
void menuCallback(int idx);

LiquidCrystal_I2C lcd =  LiquidCrystal_I2C (0x3F, 16, 2); //это глобальный экран. все обращаются к нему.
Menu menu(items,NUM_ITEMS,&lcd,menuCallback,NUM_ROWS,cursor);
 
 //=================================================================
void menuCallback(int idx){
  //do something according to index of item selected

    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print (idx);
    delay(1000);
 
 menu.goLast(); //return to last viewed menu
}
//==================================================

 


 
 int oldRotorCounter =0;
 boolean oldBut=false;


encoder myEncoder;

void IntRot () {myEncoder.rotIntrr();}
void IntBut () {myEncoder.pressIntrr();}
                 

void setup() {
  // Здесь запустим LCD, установим обработчик прерывания на котором находится кнопка, установим обработчик прерывания на котором находится ротор. 
  // создадим объект меню. 
  lcd.init ();
  lcd.backlight ();
  lcd.clear(); 
  menu.goMain();
  // устанавливаем обработчик прерывания кнопки и ротора
  attachInterrupt (0, IntRot, RISING);
  attachInterrupt (1, IntBut, CHANGE);

}

void loop() {
  // put your main code here, to run repeatedly:
  if (myEncoder.counter>oldRotorCounter) { menu.goDown();
                                              oldRotorCounter = myEncoder.counter;
                                              }
  if (myEncoder.counter<oldRotorCounter) {   menu.goUp();
                                              oldRotorCounter = myEncoder.counter;
                                              }
  
   
  if  ((myEncoder.buttonPressed !=oldBut ) && (myEncoder.buttonPressed )) {menu.goNext();                                                                 
                                                                                 oldBut =myEncoder.buttonPressed ;}
                                                                                 else {oldBut =myEncoder.buttonPressed ;}




}
